;Constant list
.include "constant_asm_V2.inc"

.data

.align    8

 SummPOPCNT:    //  POPCNT  
    .long \
                0

 .align    8

 popCountOfByte256:
    .byte \
           0, 1, 1, 2, 1, 2, 2, 3, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           5, 6, 6, 7, 6, 7, 7, 8

.text

//====================================
    .alias StartTimer.time_value_start 0x0FFFFFFFF
    .alias StartTimer.PSCPERIOD 0x00000004
    .alias StartTimer.Iteration_COUNT 1
    .alias StartTimer.Iteration_STEP 1

//====================================

    ;   
    .alias UseGPR3 1
    .alias UseSummPOPCNT 0
//====================================


//====================================

start:
    getl 0xFFFFFFFF
    wrl @1, TIM0_CNT ;
    getl 0x00000004
    wrl @1, TIM0_PSCPER ; 
    setl #3, 0
    setl #4, 0
    setl #5, 0
    setl #6, 0
    setl #7, 0
    setl #8, 0
    setl #9, 0
    setl #10, 0
    jmp timer_start
complete

timer_start:
    getl 0x00000005
    wrl @1, TIM0_CR
    jmp Get_start_time
complete

Get_start_time:

                rdl    TIM0_CNTVAL
                setl    #1, @1

                jmp    code_begin

complete

//====================================

code_begin:
    ;   StartTimer.Iteration_COUNT  StartTimer.Iteration_STEP

 r1 :=          getl    StartTimer.Iteration_COUNT
                setq    #2, @r1

                jmp    code_main

complete

//====================================

//  32  Inline mc_POPCNT32_v3
code_main:

                ;  
               ; jmp    code_loop

                ;   
 a1 :=          getl    #2            //rdl    mc_PopCnt32.ARG1
 ; a2 :=          getl    #2, 1 ; getl #R, N    P2
 ; a3 :=          getl    #2, 2
 ; a4 :=          getl    #2, 3
 ; a5 :=          getl    #2, 4
 ; a6 :=          getl    #2, 5
 ; a7 :=          getl    #2, 6
 ; a8 :=          getl    #2, 7
 
 a2 :=          addl @a1,1
 a3 :=          addl @a1,2
 a4 :=          addl @a1,3
 a5 :=          addl @a1,4
 a6 :=          addl @a1,5
 a7 :=          addl @a1,6
 a8 :=          addl @a1,7
 
                subl    @a1, StartTimer.Iteration_STEP
                setl    #2, @1
                je    @2, Get_finish_time    //    
                jne    @3, code_main
                
 s1 :=          slrl    @a1, 8
 s2 :=          slrl    @a1, 16
 s3 :=          slrl    @a1, 24
 s4 :=          slrl    @a2, 8
 s5 :=          slrl    @a2, 16
 s6 :=          slrl    @a2, 24
 s7 :=          slrl    @a3, 8
 s8 :=          slrl    @a3, 16
 s9 :=          slrl    @a3, 24
 s10 :=         slrl    @a4, 8
 s11 :=         slrl    @a4, 16
 s12 :=         slrl    @a4, 24
 s13 :=         slrl    @a5, 8
 s14 :=         slrl    @a5, 16
 s15 :=         slrl    @a5, 24
 s16 :=         slrl    @a6, 8
 s17 :=         slrl    @a6, 16
 s18 :=         slrl    @a6, 24
 s19 :=         slrl    @a7, 8
 s20 :=         slrl    @a7, 16
 s21 :=         slrl    @a7, 24
 s22 :=         slrl    @a8, 8
 s23 :=         slrl    @a8, 16
 s24 :=         slrl    @a8, 24
 
 tbl :=          getl popCountOfByte256

 l1 :=          and    @a1, 0xFF
 l2 :=          and    @s1, 0xFF
 l3 :=          and    @s2, 0xFF
 l4 :=          and    @s3, 0xFF
 l5 :=          and    @a2, 0xFF
 l6 :=          and    @s4, 0xFF
 l7 :=          and    @s5, 0xFF
 l8 :=          and    @s6, 0xFF
 l9 :=          and    @a3, 0xFF
 l10 :=         and    @s7, 0xFF
 l11 :=         and    @s8, 0xFF
 l12 :=         and    @s9, 0xFF
 l13 :=         and    @a4, 0xFF
 l14 :=         and    @s10, 0xFF
 l15 :=         and    @s11, 0xFF
 l16 :=         and    @s12, 0xFF
 l17 :=         and    @a5, 0xFF
 l18 :=         and    @s13, 0xFF
 l19 :=         and    @s14, 0xFF
 l20 :=         and    @s15, 0xFF
 l21 :=         and    @a6, 0xFF
 l22 :=         and    @s16, 0xFF
 l23 :=         and    @s17, 0xFF
 l24 :=         and    @s18, 0xFF
 l25 :=         and    @a7, 0xFF
 l26 :=         and    @s19, 0xFF
 l27 :=         and    @s20, 0xFF
 l28 :=         and    @s21, 0xFF
 l29 :=         and    @a8, 0xFF
 l30 :=         and    @s22, 0xFF
 l31 :=         and    @s23, 0xFF
 l32 :=         and    @s24, 0xFF
 
 tbl2 :=          getl popCountOfByte256

 ad1 :=         addl    @l1, @tbl
 ad2 :=         addl    @l2, @tbl
 ad3 :=         addl    @l3, @tbl
 ad4 :=         addl    @l4, @tbl
 ad5 :=         addl    @l5, @tbl
 ad6 :=         addl    @l6, @tbl
 ad7 :=         addl    @l7, @tbl
 ad8 :=         addl    @l8, @tbl
 ad9 :=         addl    @l9, @tbl
 ad10 :=        addl    @l10, @tbl
 ad11 :=        addl    @l11, @tbl
 ad12 :=        addl    @l12, @tbl
 ad13 :=        addl    @l13, @tbl
 ad14 :=        addl    @l14, @tbl
 ad15 :=        addl    @l15, @tbl
 ad16 :=        addl    @l16, @tbl
 ad17 :=        addl    @l1, @tbl
 ad18 :=        addl    @l2, @tbl
 ad19 :=        addl    @l3, @tbl
 ad20 :=        addl    @l4, @tbl
 ad21 :=        addl    @l5, @tbl
 ad22 :=        addl    @l6, @tbl
 ad23 :=        addl    @l7, @tbl
 ad24 :=        addl    @l8, @tbl
 ad25 :=        addl    @l9, @tbl
 ad26 :=        addl    @l10, @tbl
 ad27 :=        addl    @l11, @tbl
 ad28 :=        addl    @l12, @tbl
 ad29 :=        addl    @l13, @tbl
 ad30 :=        addl    @l14, @tbl
 ad31 :=        addl    @l15, @tbl2
 ad32 :=        addl    @l16, @tbl2

 rd1 :=         rdb    @ad1
 rd2 :=         rdb    @ad2
 rd3 :=         rdb    @ad3
 rd4 :=         rdb    @ad4
 rd5 :=         rdb    @ad5
 rd6 :=         rdb    @ad6
 rd7 :=         rdb    @ad7
 rd8 :=         rdb    @ad8
 rd9 :=         rdb    @ad9
 rd10 :=        rdb    @ad10
 rd11 :=        rdb    @ad11
 rd12 :=        rdb    @ad12
 rd13 :=        rdb    @ad13
 rd14 :=        rdb    @ad14
 rd15 :=        rdb    @ad15
 rd16 :=        rdb    @ad16
 rd17 :=        rdb    @ad17
 rd18 :=        rdb    @ad18
 rd19 :=        rdb    @ad19
 rd20 :=        rdb    @ad20
 rd21 :=        rdb    @ad21
 rd22 :=        rdb    @ad22
 rd23 :=        rdb    @ad23
 rd24 :=        rdb    @ad24
 rd25 :=        rdb    @ad25
 rd26 :=        rdb    @ad26
 rd27 :=        rdb    @ad27
 rd28 :=        rdb    @ad28
 rd29 :=        rdb    @ad29
 rd30 :=        rdb    @ad30
 rd31 :=        rdb    @ad31
 rd32 :=        rdb    @ad32

 ; reg3 :=        rdl 0x4004
 ; reg4 :=        rdl 0x4008
 ; reg5 :=        rdl 0x400C
 ; reg6 :=        rdl 0x4010
 ; reg7 :=        rdl 0x4014
 ; reg8 :=        rdl 0x4018
 ; reg9 :=        rdl 0x401C
 ; reg10 :=       rdl 0x4020
 
 reg3 :=        getl #3
 reg4 :=        getl #4
 reg5 :=        getl #5
 reg6 :=        getl #6
 reg7 :=        getl #7
 reg8 :=        getl #8
 reg9 :=        getl #9
 reg10 :=       getl #10
 
 it1 :=         addl    @rd1, @rd2
 it2 :=         addl    @rd3, @rd4
 it3 :=         addl    @it1, @it2
 it4 :=         addl    @rd5, @rd6
 it5 :=         addl    @rd7, @rd8
 it6 :=         addl    @it4, @it5
 it7 :=         addl    @rd9, @rd10
 it8 :=         addl    @rd11, @rd12
 it9 :=         addl    @it7, @it8
 it10 :=        addl    @rd13, @rd14
 it11 :=        addl    @rd15, @rd16
 it12 :=        addl    @it10, @it11
 it13 :=        addl    @rd17, @rd18
 it14 :=        addl    @rd19, @rd20
 it15 :=        addl    @it13, @it14
 it16 :=        addl    @rd21, @rd22
 it17 :=        addl    @rd23, @rd24
 it18 :=        addl    @it16, @it17
 it19 :=        addl    @rd25, @rd26
 it20 :=        addl    @rd27, @rd28
 it21 :=        addl    @it19, @it20
 it22 :=        addl    @rd29, @rd30
 it23 :=        addl    @rd31, @rd32
 it24 :=        addl    @it22, @it23

//   
 r1 :=          addl    @reg3, @it3
 r2 :=          addl    @reg4, @it6
 r3 :=          addl    @reg5, @it9
 r4 :=          addl    @reg6, @it12
 r5 :=          addl    @reg7, @it15
 r6 :=          addl    @reg8, @it18
 r7 :=          addl    @reg9, @it21
 r8 :=          addl    @reg10, @it24

                ; 
                setl    #3, @r1
                setl    #4, @r2
                setl    #5, @r3
                setl    #6, @r4
                setl    #7, @r5
                setl    #8, @r6
                setl    #9, @r7
                setl    #10, @r8

                ; wrl @r1, 0x40004
                ; wrl @r2, 0x40008
                ; wrl @r3, 0x4000C
                ; wrl @r4, 0x40010
                ; wrl @r5, 0x40014
                ; wrl @r6, 0x40018
                ; wrl @r7, 0x4001C
                ; wrl @r8, 0x40020

; .ifne UseSummPOPCNT //   
 ; r2 :=          rdl    SummPOPCNT
 ; r4 :=          addl    @r2, @l18

                ; ; 
               ; ; wrl    @r4, SummPOPCNT
; .endif

complete

//====================================

Get_finish_time:

 r1 :=          rdl    TIM0_CNTVAL
 r2 :=          getl    #1
 r3 :=          subl    @r2, @r1
 r4 :=          mull    @r3, 0x5

                setl    #3, @r4    ;   

                getl    0x0
                wrl    @1, TIM0_CR    ;  
                jmp end

complete

//====================================

end:
    getl #3
    wrl @1, 0x40000
    jmp full_end
complete


full_end:
    getl 123
complete

